unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Dialogs, StdCtrls, PropEditors, FormER, Grids, Menus,
  ResourceStringsManage, ComCtrls, xFMHandle, ActnList,
  ActionM, FormER0, Forms, Unit2;

type
  TForm1 = class(TFormER0)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    PropCheckBox5: TPropCheckBox;
    GroupBox3: TGroupBox;
    PropCheckBox4: TPropCheckBox;
    PropCheckBox7: TPropCheckBox;
    PropCheckBox6: TPropCheckBox;
    PropCheckBox8: TPropCheckBox;
    GroupBox4: TGroupBox;
    PropEdit1: TPropEdit;
    GroupBox5: TGroupBox;
    PropRadioButton1: TPropRadioButton;
    PropRadioButton2: TPropRadioButton;
    PropRadioButton3: TPropRadioButton;
    PropEdit2: TPropEdit;
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    ActionM1: TActionM;
    ActionM2: TActionM;
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    Label3: TLabel;
    SavethisFormtoDFMresfile1: TMenuItem;
    Edit1: TEdit;
    Edit2: TEdit;
    Button3: TButton;
    Label2: TLabel;
    Label4: TLabel;
    ActionM6: TActionM;
    ActionListM1: TActionListM;
    ActionM7: TActionM;
    LoadForm1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Label5: TLabel;
    ActionM8: TActionM;
    Registrationform1: TMenuItem;
    procedure ConvertFileResToText;
    procedure FormCreate(Sender: TObject);
    procedure SaveSelfToDFM;
    procedure SaveComponentToDFM;
    procedure CreateMenuItem;
    procedure InitForm;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ConvertFileResToText;
var
  F: String;
begin
  OpenDialog1.InitialDir:= ExePath;
  if OpenDialog1.Execute then
  begin
    F:= OpenDialog1.FileName+'.txt';
    ConvertFileResourceToText(OpenDialog1.FileName, F);
    Memo1.Lines.LoadFromFile(F);
  end;
  Label3.Caption:= 'Save to: '+F;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i:= 0 to Self.ComponentCount-1 do
    ComboBox1.Items.Add(Self.Components[i].Name);
  ComboBox1.ItemIndex := 0;
end;

procedure TForm1.SaveSelfToDFM;
begin
  with SaveDialog1 do
  begin
    InitialDir := ExePath;
    if Execute then
    begin
      Visible := False;
      Label3.Caption:= 'Save to: '+ SaveComponentResFile(FileName,Self,True);
      Visible := True;      
    end;
  end;
end;

procedure TForm1.SaveComponentToDFM;
begin
  Label3.Caption:= 'Save to: '+
   SaveComponentResFile(ComboBox1.Text,GetComponentByName(ComboBox1.Text),MakeBackupFile);
end;

procedure TForm1.CreateMenuItem;
var
  MI: TMenuItem;
  AM: TActionM;
  S: String;
begin
  AM := TActionM.Create(Self);

  // this bad declaration but it`s work
  randomize;
  S := IntToStr(Random(10))+IntToStr(Random(10))+ IntToStr(Random(10))+
    IntToStr(Random(10))+IntToStr(Random(10));

  AM.Category:= 'MacrosAction';
  AM.Name:= 'AM' + S;
  AM.Caption := Edit1.Text;
  AM.MacrosOnExecute := Edit2.Text;

  ActionListM1.AddAction(AM);

  MI := TMenuItem.Create(Self);
  MI.Name := 'MI' + S;
  MI.Action := AM;
  MainMenu1.Items.Add(MI);

end;

procedure TForm1.InitForm;
var
  Form11: TForm1;
begin
  OpenDialog1.InitialDir:= ExePath;
  OpenDialog1.FileName := 'Unit1.dfm';
  if OpenDialog1.Execute then
  begin
    FormER.Form_LoadFromFile := True;
    FormER.Form_UnitFile := OpenDialog1.FileName;
    Application.CreateForm(TForm1, Form11);
  end;
  Form11.Top := Self.Top + 30;
  Form11.Left := Self.Left + 30;

  if Form11.LoadFromFile then
    Form11.Label3.Caption:= 'Load from: '+ Form11.UnitFile
  else
    Form11.Label3.Caption:= 'Load from INT-res: Maybe file incorrect or from other module';
  if not Form11.Visible then
    Form11.ShowMe;    
end;

initialization
  Form_LoadFromFile:= True;

end.
